// ---------------------------------------------------------------------------
//	OPM-like Sound Generator
//	Copyright (C) cisc 1998, 2000.
// ---------------------------------------------------------------------------
//	$Id: opm.h,v 1.1 2000/09/08 13:45:57 cisc Exp $

#ifndef FM_OPM_H
#define FM_OPM_H

#include "fmgen.h"
#include "fmtimer.h"
#include "psg.h"

// ---------------------------------------------------------------------------
//	class OPM
//	OPM ɗǂ(?)𐶐鉹jbg
//	
//	interface:
//	bool Init(uint clock, uint rate, bool interpolation);
//		D̃NXgpOɂȂ炸ĂłƁD
//
//		clock:	OPM ̓NbN (OPNA ̏ꍇ͎ۂ 1/2 ̐l^)
//
//		rate:	 PCM ̃[g
//
//		inter.:	`⊮[h
//				true ɂƁCFM ͉̍{̃[gōs悤
//				ȂDŏIIɐ PCM  rate Ŏw肳ꂽ[gɂȂ
//				悤`⊮
//				
//		Ԃl	ɐ true
//
//	bool SetRate(uint clock, uint rate, bool interpolation)
//		NbN PCM [gύX
//		 Init QƂ̂ƁD
//	
//	void Mix(Sample* dest, int nsamples)
//		Stereo PCM f[^ nsamples C dest Ŏn܂z
//		(Z)
//		Edest ɂ sample*2 ̗̈悪Kv
//		Ei[` L, R, L, R... ƂȂD
//		E܂ŉZȂ̂ŁC炩ߔz[NAKv
//		ESample  32bit int z肵Ă̂ŁC̊֐ł̓NbsO
//		  sȂD
//		E̊֐͉̃^C}[Ƃ͖łD
//		  Timer ͂܂ Count  GetNextEvent ő삷KvD
//	
//	void Reset()
//		Zbg()
//
//	void SetReg(uint reg, uint data)
//		̃WX^ reg  data 
//	
//	uint GetReg(uint reg)
//		̃WX^ reg ̓eǂݏo
//		ǂݍނƂo郌WX^ PSG, ADPCM ̈ꕔCID(0xff) Ƃ
//	
//	uint ReadStatus()
//		̃Xe[^XWX^ǂݏo
//		busy tO͏ 0
//	
//	bool Count(uint32 t)
//		̃^C}[ t [ʕb] i߂D
//		̓Ԃɕω(timer I[o[t[)
//		true Ԃ
//
//	uint32 GetNextEvent()
//		̃^C}[̂ǂ炩I[o[t[܂łɕKv
//		[ʕb]Ԃ
//		^C}[~Ăꍇ 0 Ԃ܂D
//	
//	void SetVolume(int db)
//		ẻʂ{|ɒ߂DWl 0.
//		Pʂ͖ 1/2 dBCL͈͂̏ 20 (10dB)
//
//	z֐:
//	virtual void Intr(bool irq)
//		IRQ o͂ɕωꍇĂ΂D
//		irq = true:  IRQ v
//		irq = false: IRQ v
//
namespace FM
{
	//	YM2151(OPM) ----------------------------------------------------
	class OPM : public Timer
	{
	public:
		OPM();
		~OPM() {}
		
		bool	Init(uint c, uint r, bool=false);
		bool	SetRate(uint c, uint r, bool);
		void	Reset();
		
		void 	SetReg(uint addr, uint data);
		uint	GetReg(uint addr);
		uint	ReadStatus() { return status & 0x03; }
		
		void 	Mix(Sample* buffer, int nsamples);
		
		void	SetVolume(int db);
		void	SetChannelMask(uint mask);
		
	private:
		void	SetStatus(uint bit);
		void	ResetStatus(uint bit);
		void	SetParameter(uint addr, uint data);
		void	TimerA();
		void	RebuildTimeTable();
		void	MixSub(int activech, ISample**);
		void	MixSubL(int activech, ISample**);
		void	LFO();
		uint	Noise();
		
		virtual void Intr(bool) {}
		
		int32	mixl, mixr, mixdelta;
		int		mpratio;
		bool	interpolation;
		
		int		fmvolume;

		uint	clock;
		uint	rate;
		int		fbch;

		uint	pmd;
		uint	amd;
		uint	lfocount;
		uint	lfodcount;
		uint	lfowaveform;
		uint	rateratio;
		uint	noise;
		int32	noisecount;
		uint32	noisedelta;
		
		uint8	lfofreq;
		uint8	status;
		uint8	reg01;

		uint8	kc[8];
		uint8	kf[8];
		uint8	pan[8];

		Channel4 ch[8];

		static void	BuildLFOTable();
		static int amtable[4][FM_LFOENTS];
		static int pmtable[4][FM_LFOENTS];
	};
}

#endif // FM_OPM_H
